package org.jivesoftware.spellchecker;

import java.io.File;
import java.io.InputStream;

import org.dts.spell.SpellChecker;
import org.dts.spell.dictionary.OpenOfficeSpellDictionary;
import org.dts.spell.dictionary.SpellDictionary;
import org.jivesoftware.spark.SparkManager;
import org.jivesoftware.spark.plugin.Plugin;

public class SpellcheckerPlugin implements Plugin
{
	private SpellcheckChatRoomListener listener;
	
	public boolean canShutDown() {
		return true;
	}

	public void initialize() {
		
		try
		{	
			String language = SparkManager.getMainWindow().getLocale().getLanguage();
			File personalDictionary =  new File(SparkManager.getUserDirectory(), "personalDictionary.dict");			
			InputStream dictionary  = getClass().getClassLoader().getResourceAsStream(language + ".zip");
			
			if (dictionary != null)
				System.out.println("Dictionary: " + language + ".zip");
			else
				System.out.println("Dictionary not found");
			
			
			SpellDictionary dict = new OpenOfficeSpellDictionary(dictionary,personalDictionary);
			SpellChecker checker = new SpellChecker(dict);
			listener = new SpellcheckChatRoomListener(checker);			
			SparkManager.getChatManager().addChatRoomListener(listener);
			SparkManager.getPreferenceManager().addPreference(new SpellcheckerPreference());
		}
		catch (Exception e)
		{
			e.printStackTrace();
		}
	}

	public void shutdown() {
	
	}

	public void uninstall() {
		SparkManager.getChatManager().removeChatRoomListener(listener);
	}

}
