package org.jivesoftware.spellchecker;

import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Insets;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.BorderFactory;
import javax.swing.JCheckBox;
import javax.swing.JPanel;

import org.jivesoftware.resource.Res;
import org.jivesoftware.spark.component.VerticalFlowLayout;

public class SpellcheckerPreferenceDialog extends JPanel implements ActionListener
{
	private static final long serialVersionUID = -1836601903928057855L;

	
	private JCheckBox spellcheckingEnabled = new JCheckBox();
	private JCheckBox autospellcheckingEnabled = new JCheckBox();
	private JPanel spellPanel = new JPanel();
	
	public SpellcheckerPreferenceDialog()
	{
		spellPanel.setLayout(new GridBagLayout());
		
		spellcheckingEnabled.setText("Enable Spellchecking");
		
		spellcheckingEnabled.addActionListener(this);
		
		autospellcheckingEnabled.setText("Enable Auto Spellchecking");
		
		spellPanel.add(spellcheckingEnabled, new GridBagConstraints(0, 0, 2, 1, 1.0, 1.0, GridBagConstraints.NORTHWEST, GridBagConstraints.NONE, new Insets(5, 5, 5, 5), 0, 0));
		spellPanel.add(autospellcheckingEnabled, new GridBagConstraints(0, 1, 2, 1, 1.0, 1.0, GridBagConstraints.NORTHWEST, GridBagConstraints.NONE, new Insets(5, 5, 5, 5), 0, 0));
		
		
		setLayout(new VerticalFlowLayout());
		spellPanel.setBorder(BorderFactory.createTitledBorder("Spellchecking"));
        add(spellPanel);
	}
	
	public void updateUI(boolean enable)
	{
		if (enable)
		{
			autospellcheckingEnabled.setEnabled(true);
		}
		else
		{
			autospellcheckingEnabled.setEnabled(false);
		}		
	}
	
	public void setSpellCheckingEnabled(boolean enable)
	{
		spellcheckingEnabled.setSelected(enable);
		updateUI(enable);
	}
	
	public void setAutoSpellCheckingEnabled(boolean enable)
	{
		autospellcheckingEnabled.setSelected(enable);
	}
	
	 public boolean isSpellCheckingEnabled() {
		 return spellcheckingEnabled.isSelected();
	 }
	 
	 public boolean isAutoSpellCheckingEnabled() {
		 return autospellcheckingEnabled.isSelected();
	 }

	 public void actionPerformed(ActionEvent event) {
		 updateUI(spellcheckingEnabled.isSelected());
	 }
}
